unit AdminBackup;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls,
  InstanceSections, AdditionalClasses,
  ImgList, Buttons, Contnrs, Menus, ApplicationDataModule, AuxFuncs,
  myx_public_interface, myx_admin_public_interface, SchemataTreeView,
  AdvancedEdit, PNGImage,
  AdminBackupProgress, AuxAdminBackupRestore,
  MySQLConnection, Options, MyxError, TntExtCtrls,TntComCtrls,
  ScheduleAPI, Math, VirtualTrees, OptionsEditor, AdminOptionPages,
  TntMenus, TntStdCtrls, TntForms, TntClasses, TntDialogs;

type
  TAtEnum = record
    JobId: DWord;
    JobTime: DWord;
    DaysOfMonth: DWord;
    DaysOfWeek: Byte;
    Flags: Byte;
    Command: WideString;
  end;

  TBackupThread = class;

  TAdminBackupForm = class(TInstanceSectionForm)
    ServerBackupRestorePnl: TTntPanel;
    BackupRestorePageControl: TTntPageControl;
    BackupContentTabSheet: TTabSheet;
    ItemSelectImageList: TImageList;
    Panel1: TTntPanel;
    RestoreBevel: TTntBevel;
    Label3: TTntLabel;
    Backup2Img: TTntImage;
    SubTreePnl: TTntPanel;
    BackupTreeViewPopupMenu: TTntPopupMenu;
    RemoveBackupNodeMI: TTntMenuItem;
    ProfilesPopupMenu: TTntPopupMenu;
    RefreshProfilesMI: TTntMenuItem;
    SchemataFrame: TSchemataFrame;
    ContentSplitter: TTntSplitter ;
    Panel2: TTntPanel;
    TopPnl: TTntPanel;
    SchemataLbl: TTntLabel;
    AdvancedEditFrame: TAdvancedEditFrame;
    SpacerPnl: TTntPanel;
    ProjectListView: TTntListView;
    AddSchemaToBackupBtn: TTntButton;
    RemoveSchemaFromBackup: TTntButton;
    Panel3: TTntPanel;
    BackupTreeView: TTntTreeView;
    BackupTreeViewHeaderControl: THeaderControl;
    Panel4: TTntPanel;
    Label1: TTntLabel;
    Label2: TTntLabel;
    Panel7: TTntPanel;
    N1: TTntMenuItem;
    DeleteProfileMI: TTntMenuItem;
    ClearCompleteContentMI: TTntMenuItem;
    AdvancedOptionsTabSheet: TTabSheet;
    Panel5: TTntPanel;
    Bevel1: TTntBevel;
    Label15: TTntLabel;
    Backup3Img: TTntImage;
    Label16: TTntLabel;
    NewProjectBtn: TTntButton;
    ApplyBtn: TTntButton;
    StartBackupBtn: TTntButton;
    Panel9: TTntPanel;
    GroupBox1: TTntGroupBox;
    Label4: TTntLabel;
    Label5: TTntLabel;
    ProjectNameEd: TTntEdit;
    ScheduleTabSheet: TTabSheet;
    ScheduleGBox: TTntGroupBox;
    ScheduleTargetDirCaptionLbl: TTntLabel;
    ScheduleTargetDirLbl: TTntLabel;
    SchedulePrefixCaptionLbl: TTntLabel;
    SchedulePrefixLbl: TTntLabel;
    ScheduleLbl: TTntLabel;
    ScheduleTargetDirEd: TTntEdit;
    ScheduleBrowseTargetDirBtn: TTntButton;
    ScheduleFilenamePrefixEd: TTntEdit;
    ScheduleCBox: TTntCheckBox;
    Panel6: TTntPanel;
    BackupBevel: TTntBevel;
    Label6: TTntLabel;
    BackupImg: TTntImage;
    Label7: TTntLabel;
    ExecutionTimeGBox: TTntGroupBox;
    SchedulePageControl: TTntPageControl;
    DailyTabSheet: TTabSheet;
    Label26: TTntLabel;
    WeeklyTabSheet: TTabSheet;
    Label21: TTntLabel;
    ScheduleMondayCBox: TTntCheckBox;
    ScheduleTuesdayCBox: TTntCheckBox;
    ScheduleWednesdayCBox: TTntCheckBox;
    ScheduleThursdayCBox: TTntCheckBox;
    ScheduleFridayCBox: TTntCheckBox;
    ScheduleSaturdayCBox: TTntCheckBox;
    ScheduleSundayCBox: TTntCheckBox;
    TabSheet3: TTabSheet;
    Label22: TTntLabel;
    Label20: TTntLabel;
    Label25: TTntLabel;
    ScheduleDayOfMonthCBox: TTntComboBox;
    TimePnl: TTntPanel;
    Label23: TTntLabel;
    Label24: TTntLabel;
    ScheduleTimeEd: TTntEdit;
    ScheduleTypeCbox: TTntComboBox;
    Panel10: TTntPanel;
    AdvOptionsScrollBox: TTntScrollBox;
    BackExecuteGBox: TTntGroupBox;
    Label17: TTntLabel;
    Label18: TTntLabel;
    Label19: TTntLabel;
    Label14: TTntLabel;
    LockAllTablesRButton: TTntRadioButton;
    SingleTransRButton: TTntRadioButton;
    RadioButton3: TTntRadioButton;
    CompleteSchematasCBox: TTntCheckBox;
    OutputFileGBox: TTntGroupBox;
    Label12: TTntLabel;
    Label13: TTntLabel;
    NoCreatesCBox: TTntCheckBox;
    NoExtendedInsertsCBox: TTntCheckBox;
    AddDropTableCBox: TTntCheckBox;
    CompleteInsertsCBox: TTntCheckBox;
    CommentCBox: TTntCheckBox;
    FullPathCBox: TTntCheckBox;
    AnsiQuotesCBox: TTntCheckBox;
    DisableKeysCBox: TTntCheckBox;
    BackupFileTypesLU: TTntComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure RefreshSchemaTree(searchStr: WideString = '');
    procedure ServerBackupRestorePnlResize(Sender: TObject);
    procedure BackupTreeViewAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure BackupTreeViewMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BackupTreeViewHeaderControlSectionResize(
      HeaderControl: THeaderControl; Section: THeaderSection);

    procedure AddSchemaToBackupBtnClick(Sender: TObject);
    procedure AddSchemaToBackup(Schema: TMYX_SCHEMA; Selected: Boolean = True);
    procedure BackupTreeViewDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure BackupTreeViewDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure SchemaTreeViewExpanding(Sender: TObject; Node: TTntTreeNode;
      var AllowExpansion: Boolean);
    procedure BackupTreeViewPopupMenuPopup(Sender: TObject);
    procedure RemoveBackupNodeMIClick(Sender: TObject);

    procedure RemoveTreeNode(Node: TTntTreeNode);
    procedure SchemaTreeViewCollapsing(Sender: TObject; Node: TTntTreeNode;
      var AllowCollapse: Boolean);
    procedure SchemataFrameSchemaTreeViewMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StartBackupBtnClick(Sender: TObject);

    procedure NewProjectBtnClick(Sender: TObject);
    procedure BackupTreeViewChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure ClearControls(EnableControls: Boolean);
    procedure ProjectNameEdExit(Sender: TObject);
    procedure ScheduleBrowseTargetDirBtnClick(Sender: TObject);
    procedure DoChange(Sender: TObject);
    procedure DiscardBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);

    procedure RefreshBackupProfiles(SelectProfile: WideString = '');

    procedure ApplyChanges;
    procedure DiscardChanges(AskBeforeDiscard: Boolean);

    procedure LoadProfile(filename: WideString);
    function GetSelectedTablesCount: integer;

    function GetOptions: integer;
    procedure AddOption(var options: integer;
      option: MYX_BACKUP_OPTIONS; Add: Boolean);
    function InOptions(options: integer; option: MYX_BACKUP_OPTIONS): Boolean;
    procedure RefreshProfilesMIClick(Sender: TObject);
    procedure DeleteProfileMIClick(Sender: TObject);
    procedure ProfilesPopupMenuPopup(Sender: TObject);
    procedure ClearCompleteContentMIClick(Sender: TObject);
    procedure ProjectListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);

    procedure Disconnected(var Message: TMessage); message WM_Disconnected;
    procedure Reconnected(var Message: TMessage); message WM_Reconnected;
    procedure SchemaListChanged(var Message: TMessage); message WM_SchemaListChanged;
    procedure AdvancedEditFrameSearchEdChange(Sender: TObject);

    function GetNextJobId: integer;
    function GetSchedule(ProjectName: WideString): TAtEnum;
    procedure DisableEnableScheduleControls;
    procedure ScheduleCBoxClick(Sender: TObject);

    procedure RemoveSchedule(ProjectName: WideString);
    procedure ScheduleTypeCboxCloseUp(Sender: TObject);
    procedure SchemataFrameCatalogVSTMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure SchemataFrameCatalogVSTDblClick(Sender: TObject);
  private
    { Private declarations }
    MousePos: TPoint;

    BackupPNGImg: TPNGObject;

    BackupProfileDir: WideString;

    BackupThread: TBackupThread;

    OriginalProjectName: WideString;
  public
    { Public declarations }
    CurrentCatalog: TMYX_CATALOG;
    CurrentSchema: TMYX_SCHEMA;

    //User must not expand SchemaTree manually
    LockSchemaTreeExpansion: Boolean;
  end;

  TBackupThread = class(TThread)
    constructor Create(AdminBackupForm: TAdminBackupForm;
      AdminBackupProgressForm: TAdminBackupProgressForm;
      filename: WideString);
    destructor Destroy; override;

    procedure UpdateProgressForm;
    procedure FinishedBackup;
    procedure FreeAdminBackupProgressForm;
    procedure ShowError;
    procedure CleanUp;
  protected
    procedure Execute; override;
  private
    PMySQL: Pointer;

    AdminBackupForm: TAdminBackupForm;
    filename: WideString;
  public
    AdminBackupProgressForm: TAdminBackupProgressForm;

    current_table_name: WideString;
    num_tables: integer;
    num_tables_processed: integer;
    num_rows: integer;
    num_rows_processed: integer;

    BackupError: MYX_BACKUP_ERROR;
  end;

  function BackupProgress(current_table_name: PChar;
    num_tables: Integer; num_tables_processed: Integer;
    num_rows: Integer; num_rows_processed: Integer;
    user_data: Pointer): integer; cdecl;


implementation

{$R *.dfm}

uses Main;

procedure TAdminBackupForm.FormCreate(Sender: TObject);
begin
  InitForm(self);

  DockedPanel:=ServerBackupRestorePnl;
  SubTreePanel:=SubTreePnl;

  BackupRestorePageControl.ActivePageIndex:=0;

  CurrentCatalog:=nil;
  CurrentSchema:=nil;

  BackupThread:=nil;

  InitControls:=True;

  LockSchemaTreeExpansion:=True;

  SchemataFrame.MySQLConn:=MySQLConn;
  SchemataFrame.ShowSchemaAssets:=False;
  SchemataFrame.ShowTablesOnSchemaExpansion:=True;
  SchemataFrame.RefreshSchemaTree;

  BackupPNGImg:=LoadPNGImageFromResource('backup', BackupImg);
  Backup2Img.Picture.Assign(BackupPNGImg);
  Backup3Img.Picture.Assign(BackupPNGImg);

  if(MYXCommonOptions.XPStyleEnabled)then
  begin
    ContentSplitter.Color:=clWhite;
    ExecutionTimeGBox.Color:=clWhite;
    AdvOptionsScrollBox.Color:=clWhite;
  end;

  ClearControls(False);

  if(Not(MySQLConn.Connected))then
    NewProjectBtn.Enabled:=False;

  //BackupProfileDir:=ExtractFilePath(Application.ExeName);
  BackupProfileDir:=MYXCommonOptions.UserDataDir;

  RefreshBackupProfiles;

  ScheduleTypeCbox.ItemIndex:=1;
  SchedulePageControl.ActivePageIndex:=1;
  ScheduleDayOfMonthCBox.ItemIndex:=0;
end;

procedure TAdminBackupForm.FormDestroy(Sender: TObject);
begin
  BackupPNGImg.Free;

  ClearListView(ProjectListView, myx_ndt_pointer);
end;

procedure TAdminBackupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;


procedure TAdminBackupForm.RefreshSchemaTree(searchStr: WideString = '');
begin
  //
end;

procedure TAdminBackupForm.ServerBackupRestorePnlResize(
  Sender: TObject);
//var InitSheetWidth, InitSheetHeight: integer;
begin
  {InitSheetWidth:=563;
  InitSheetHeight:=451;

  //Adjust Page Control
  BackupRestorePageControl.Width:=ServerBackupRestorePnl.Width-591+571;
  BackupRestorePageControl.Height:=ServerBackupRestorePnl.Height-501+443;}

  //Backup Sheet
  BackupTreeViewHeaderControl.Left:=BackupTreeView.Left+1;
  BackupTreeViewHeaderControl.Width:=BackupTreeView.Width-2-18;
end;

procedure TAdminBackupForm.BackupTreeViewAdvancedCustomDrawItem(
  Sender: TCustomTreeView; Node: TTreeNode; State: TCustomDrawState;
  Stage: TCustomDrawStage; var PaintImages, DefaultDraw: Boolean);
var NodeRect: TRect;
  XPos: integer;
  theHeaderControl: THeaderControl;
  i: integer;
begin
  theHeaderControl:=BackupTreeViewHeaderControl;

  if(Stage=cdPrePaint)then
  begin
    Sender.Canvas.Pen.Style:=psSolid;
    if(cdsFocused in State)then
      Sender.Canvas.Pen.Color:=clGray
    else
      Sender.Canvas.Pen.Color:=clSilver;

    NodeRect:=Node.DisplayRect(False);

    if(cdsSelected in State)then
    begin
      Sender.Canvas.Brush.Color:=clWhite;
      Sender.Canvas.Pen.Color:=clGray;
      Sender.Canvas.Rectangle(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom);
    end
    else
    begin
      Sender.Canvas.Brush.Color:=clWhite;
      Sender.Canvas.FillRect(Rect(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
        Sender.Width-4-18, NodeRect.Bottom+1));
    end;

    Sender.Canvas.Brush.Color:=clWhite;

    DefaultDraw:=True;
  end
  else if(Stage=cdPostPaint)then
  begin
    if(Node.Data<>nil)then
    begin
      NodeRect:=Node.DisplayRect(False);

      if(cdsFocused in State)then
      begin
        Sender.Canvas.Pen.Color:=clGray;
        Sender.Canvas.Pen.Style:=psSolid;
        Sender.Canvas.Brush.Color:=clSilver;

        Sender.Canvas.Rectangle(NodeRect.Left+19+Node.Level*19+5-2, NodeRect.Top,
          Sender.Width-4-18, NodeRect.Bottom);

        Sender.Canvas.Brush.Style:=bsClear;

        Sender.Canvas.TextRect(Rect(
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          theHeaderControl.Sections[0].Width+2, NodeRect.Top+16),
          NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
          Node.Text);
      end;

      ItemSelectImageList.Draw(Sender.Canvas,
        NodeRect.Left+19+Node.Level*19+5, NodeRect.Top+1,
        Ord(TBackupNode(Node.Data).GetSelectState));

      if(TBackupNode(Node.Data).GetObjType=BOTTable)and
        (TBackupNode(Node.Data).Substrings<>nil)then
      begin
        Sender.Canvas.Brush.Style:=bsClear;
        XPos:=0;
        for i:=0 to 3 do
        begin
          XPos:=XPos+theHeaderControl.Sections[i].Width;
          Sender.Canvas.TextRect(Rect(XPos+2, NodeRect.Top+1,
            XPos+theHeaderControl.Sections[i+1].Width-4, NodeRect.Top+16),
            XPos+2, NodeRect.Top+1,
            TBackupNode(Node.Data).Substrings[i]);
        end;
      end;
    end;
  end;
end;

procedure TAdminBackupForm.BackupTreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Node: TTntTreeNode;
  NodeRect: TRect;
  Selected: TBackupCheckType;
begin
  Node:=TTntTreeView(Sender).GetNodeAt(x, y);
  if(Assigned(Node))then
  begin
    NodeRect:=Node.DisplayRect(False);

    if(X>NodeRect.Left+19+Node.Level*19+5)and(X<NodeRect.Left+19+Node.Level*19+5+14)and
      (Node.Data<>nil)then
    begin
      if(TBackupNode(Node.Data).GetSelectState<>BCTAll)then
        Selected:=BCTAll
      else
        Selected:=BCTNone;

      SetNodeSelectState(Node, Selected);

      DoChange(self);
    end;
  end;
end;

procedure TAdminBackupForm.BackupTreeViewHeaderControlSectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  BackupTreeView.Invalidate;
end;

procedure TAdminBackupForm.AddSchemaToBackup(Schema: TMYX_SCHEMA; Selected: Boolean);
var CatalogNode, SchemaNode: TTntTreeNode;
  i: integer;
  ptable_status: PMYX_SCHEMA_TABLE_STATUS;
  table_status: TMYX_SCHEMA_TABLE_STATUS;
  backup_node: TBackupNode;
begin
  CatalogNode:=nil;

  //Check if schema not already in Backup List
  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTSchema)then
          if(CompareText(TBackupNode(BackupTreeView.Items[i].Data).GetObjName,
            Schema.schema_name)=0)then
          begin
            //If Node has a parent, check catalog name, too
            if(BackupTreeView.Items[i].Parent<>nil)then
            begin
              if(BackupTreeView.Items[i].Parent.Data<>nil)then
                if(TObject(BackupTreeView.Items[i].Parent.Data) is TBackupNode)then
                  if(TBackupNode(BackupTreeView.Items[i].Parent.Data).GetObjType=BOTCatalog)then
                    if(CompareText(TBackupNode(BackupTreeView.Items[i].Parent.Data).GetObjName,
                      Schema.catalog_name)=0)then
                        Exit;
            end
            else
              Exit;
          end;

  if(BackupTreeView.Items.Count=0)then
    AddTreeViewChildNode(BackupTreeView, nil, 'BackupRoot', -1, nil);

  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTCatalog)then
          if(CompareText(TBackupNode(BackupTreeView.Items[i].Data).GetObjName,
            Schema.catalog_name)=0)then
          begin
            CatalogNode:=BackupTreeView.Items[i];
            break;
          end;


  if(CatalogNode=nil)then
  begin
    CatalogNode:=AddTreeViewChildNode(BackupTreeView, nil, //BackupTreeView.Items[0],
      '      '+Schema.catalog_name, 2,
      TBackupNode.Create(Schema.catalog_name, BOTCatalog));
  end;

  SchemaNode:=AddTreeViewChildNode(BackupTreeView, CatalogNode,
    '      '+Schema.schema_name, 9,
    TBackupNode.Create(Schema.schema_name, BOTSchema));

  //----------------------------------------------------------
  //Get Tables
  ptable_status:=myx_get_schema_table_status(MySQLConn.PMySQL, '',
    Schema.schema_name);
  try
    table_status:=TMYX_SCHEMA_TABLE_STATUS.Create(ptable_status);

    for i:=0 to table_status.schema_tables.Count-1 do
    begin
      backup_node:=TBackupNode.Create(
        table_status.schema_tables[i].table_name, BOTTable);
      backup_node.Substrings:=TTntStringList.Create;
      backup_node.Substrings.Add(
        table_status.schema_tables[i].table_type);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].rows);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].data_length);
      backup_node.Substrings.Add(
        table_status.schema_tables[i].update_time);

      AddTreeViewChildNode(BackupTreeView, SchemaNode, '      '+
        table_status.schema_tables[i].table_name, 10,
        backup_node);
    end;

    //Select new Schema and all subnodes (tables)
    if(Selected)then
      SetNodeSelectState(SchemaNode, BCTAll);

    table_status.Free;
  finally
    myx_free_schema_table_status(ptable_status);
  end;

  //Expand nodes
  BackupTreeView.Items[0].Expand(False);
  CatalogNode.Expand(False);
end;

procedure TAdminBackupForm.BackupTreeViewDragOver(Sender,
  Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if(Source=SchemataFrame.CatalogVST)then
    Accept:=True;
end;

procedure TAdminBackupForm.BackupTreeViewDragDrop(Sender,
  Source: TObject; X, Y: Integer);
begin
  if(Source=SchemataFrame.CatalogVST)then
  begin
    AddSchemaToBackupBtnClick(self);
  end;
end;

procedure TAdminBackupForm.SchemaTreeViewExpanding(Sender: TObject;
  Node: TTntTreeNode; var AllowExpansion: Boolean);
begin
  //Expansion not allowed in Backup/Restore
  AllowExpansion:=Not(LockSchemaTreeExpansion);
end;

procedure TAdminBackupForm.BackupTreeViewPopupMenuPopup(
  Sender: TObject);
begin
  //Tables cannot be removed
  RemoveBackupNodeMI.Enabled:=True;
  if(BackupTreeView.Selected<>nil)then
    if(BackupTreeView.Selected.Data<>nil)then
      if(TBackupNode(BackupTreeView.Selected.Data).GetObjType=BOTTable)then
        RemoveBackupNodeMI.Enabled:=False;
end;

procedure TAdminBackupForm.RemoveBackupNodeMIClick(Sender: TObject);
begin
  if(BackupTreeView.Selected<>nil)then
    if(BackupTreeView.Selected.Data<>nil)then
    begin
      RemoveTreeNode(BackupTreeView.Selected);

      DoChange(self);

      StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
    end;
end;

procedure TAdminBackupForm.RemoveTreeNode(Node: TTntTreeNode);
begin
  //Remove Child nodes first
  while(Node.Count>0)do
    RemoveTreeNode(Node.Item[0]);

  TBackupNode(Node.Data).Free;

  TTntTreeView(Node.TreeView).Items.Delete(Node);
end;

procedure TAdminBackupForm.SchemaTreeViewCollapsing(Sender: TObject;
  Node: TTntTreeNode; var AllowCollapse: Boolean);
begin
  if(Node.Data<>nil)then
    if(TObject(Node.Data) is TMYX_CATALOG)then
      AllowCollapse:=False;
end;

procedure TAdminBackupForm.AddSchemaToBackupBtnClick(
  Sender: TObject);
var i, j: integer;
  Selection: TNodeArray;
  NodeData: ^TObject;
begin
  Selection:=SchemataFrame.CatalogVST.GetSortedSelection(False);

  for i:=0 to SchemataFrame.CatalogVST.SelectedCount-1 do
  begin
    NodeData:=SchemataFrame.CatalogVST.GetNodeData(Selection[i]);
    if(NodeData<>nil)then
      if(NodeData^<>nil)then
      begin
        if(NodeData^ is TMYX_SCHEMA)then
          AddSchemaToBackup(TMYX_SCHEMA(NodeData^));

        if(NodeData^ is TMYX_CATALOG)then
          for j:=0 to TMYX_CATALOG(NodeData^).Schemata.Count-1 do
            AddSchemaToBackup(TMYX_CATALOG(NodeData^).Schemata[j]);
      end;
  end;

  DoChange(self);

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

procedure TAdminBackupForm.SchemataFrameSchemaTreeViewMouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if(Button=mbLeft)then
  begin
    MousePos:=Mouse.CursorPos;
  end;
end;

procedure TAdminBackupForm.StartBackupBtnClick(Sender: TObject);
var
  SaveDialog: TTntSaveDialog;
  filename: WideString;
  AdminBackupProgressForm: TAdminBackupProgressForm;
begin
  SaveDialog:=TTntSaveDialog.Create(self);
  try
    if(ApplicationDM.Options.AddDateTimeToBackupFiles)then
      SaveDialog.FileName:=ProjectNameEd.Text+
        FormatDateTime(' yyyymmdd hhnn', Now)+'.sql'
    else
      SaveDialog.FileName:=ProjectNameEd.Text+'.sql';

    SaveDialog.Filter:='SQL Backup Files|*.sql|All Files|*.*';

    if(Not(SaveDialog.Execute))then
      Exit;

    filename:=SaveDialog.Filename;
  finally
    SaveDialog.Free;
  end;

  AdminBackupProgressForm:=TAdminBackupProgressForm.Create(
    self, True,
    ProjectNameEd.Text);
  AdminBackupProgressForm.Show;

  BackupThread:=TBackupThread.Create(self, AdminBackupProgressForm,
    filename);
  try
    //Thread will be freed after execution
    BackupThread.FreeOnTerminate:=True;

    BackupThread.Resume;
  except
    BackupThread.Free;
  end;
end;

procedure TAdminBackupForm.BackupTreeViewChanging(Sender: TObject;
  Node: TTreeNode; var AllowChange: Boolean);
begin
  if(BackupTreeView.Items.Count>0)then
    if(Node=BackupTreeView.Items[0])then
      AllowChange:=False;
end;

procedure TAdminBackupForm.ClearControls(EnableControls: Boolean);
begin
  InitControls:=True;

  DisableEnableControls(BackupContentTabSheet, EnableControls);
  DisableEnableControls(AdvancedOptionsTabSheet, EnableControls);
  DisableEnableControls(ScheduleTabSheet, EnableControls);
  DisableEnableScheduleControls;

  ApplyBtn.Enabled:=False;
  //DiscardBtn.Enabled:=False;
  StartBackupBtn.Enabled:=False;

  ProjectNameEd.Text:='';
  ScheduleTargetDirEd.Text:='';
  ScheduleFilenamePrefixEd.Text:='';

  NoCreatesCBox.Checked:=False;
  NoExtendedInsertsCBox.Checked:=False;
  AddDropTableCBox.Checked:=False;
  CompleteInsertsCBox.Checked:=True;
  CommentCBox.Checked:=False;
  FullPathCBox.Checked:=False;
  AnsiQuotesCBox.Checked:=False;
  LockAllTablesRButton.Checked:=True;
  DisableKeysCBox.Checked:=False;
  CompleteSchematasCBox.Checked:=False;

  BackupFileTypesLU.ItemIndex:=0;

  ClearTreeView(BackupTreeView, myx_ndt_tobject);

  ScheduleCBox.Checked:=False;
  ScheduleTypeCbox.ItemIndex:=1;
  SchedulePageControl.ActivePageIndex:=1;

  ScheduleMondayCBox.Checked:=False;
  ScheduleTuesdayCBox.Checked:=False;
  ScheduleWednesdayCBox.Checked:=False;
  ScheduleThursdayCBox.Checked:=False;
  ScheduleFridayCBox.Checked:=False;
  ScheduleSaturdayCBox.Checked:=False;
  ScheduleSundayCBox.Checked:=False;

  ScheduleTimeEd.Text:='23:00';

  InitControls:=False;
end;

procedure TAdminBackupForm.DisableEnableScheduleControls;
begin
  ScheduleTargetDirCaptionLbl.Enabled:=ScheduleCBox.Checked;
  ScheduleTargetDirEd.Enabled:=ScheduleCBox.Checked;
  ScheduleBrowseTargetDirBtn.Enabled:=ScheduleCBox.Checked;
  ScheduleTargetDirLbl.Enabled:=ScheduleCBox.Checked;
  SchedulePrefixCaptionLbl.Enabled:=ScheduleCBox.Checked;
  ScheduleFilenamePrefixEd.Enabled:=ScheduleCBox.Checked;
  SchedulePrefixLbl.Enabled:=ScheduleCBox.Checked;

  DisableEnableControls(ExecutionTimeGBox, ScheduleCBox.Checked);
end;


procedure TAdminBackupForm.NewProjectBtnClick(Sender: TObject);
begin
  DiscardChanges(True);

  OriginalProjectName:='';

  BackupRestorePageControl.ActivePageIndex:=0;

  ProjectListView.Selected:=nil;
  ClearControls(True);

  ProjectNameEd.Text:='New Project';
  ProjectNameEd.SetFocus;
  ProjectNameEd.SelectAll;
end;

procedure TAdminBackupForm.ProjectNameEdExit(Sender: TObject);
begin
  if(ExtractText(ProjectNameEd.Text)<>ProjectNameEd.Text)then
  begin
    ProjectNameEd.SetFocus;
    raise EInOutError.Create(_('You can only use alphanumeric characters for project name.'));
  end;
end;

procedure TAdminBackupForm.ScheduleBrowseTargetDirBtnClick(Sender: TObject);
var SaveDialog: TTntSaveDialog;
begin
  SaveDialog:=TTntSaveDialog.Create(self);
  SaveDialog.Title:=_('Choose Target Directory');
  SaveDialog.InitialDir:='';
  SaveDialog.FileName:=_('Browse to the Target Directory');

  if(SaveDialog.Execute)then
  begin
    ScheduleTargetDirEd.Text:=ExtractFilePath(SaveDialog.FileName);
  end;
end;

procedure TAdminBackupForm.DoChange(Sender: TObject);
begin
  if(Not(InitControls))then
  begin
    ApplyBtn.Enabled:=True;
    //DiscardBtn.Enabled:=True;
  end;
end;

procedure TAdminBackupForm.DiscardChanges(AskBeforeDiscard: Boolean);
var res: integer;
begin
  if(Not(ApplyBtn.Enabled))then
  begin
    OriginalProjectName:='';

    Exit;
  end;

  if(AskBeforeDiscard)then
  begin
    res:=ShowModalDialog(_('Apply changes?'),
      _('The current backup profile has been changed. '+
      'Do you want to apply your changes?'),
      myx_mtConfirmation,
      _('Yes')+#13#10+_('No')+#13#10+_('Abort'));
    if(res=1)then
    begin
      ApplyChanges;
      Exit;
    end
    else if(res=3)then
      Abort;
  end;

  if(ProjectListView.Selected=nil)then
    ClearControls(False)
  else
  begin
    ApplyBtn.Enabled:=False;
    //DiscardBtn.Enabled:=False;

    //Reload profile
    LoadProfile(UTF8Decode(PChar(ProjectListView.Selected.Data)));
  end;
end;

function TAdminBackupForm.GetOptions: integer;
var options: integer;
begin
  options:=0;

  AddOption(options, MYX_B_NO_CREATES, NoCreatesCBox.Checked);
  AddOption(options, MYX_B_NO_EXTENDED_INSERT, NoExtendedInsertsCBox.Checked);
  AddOption(options, MYX_B_ADD_DROP_TABLE, AddDropTableCBox.Checked);
  AddOption(options, MYX_B_COMPLETE_INSERTS, CompleteInsertsCBox.Checked);
  AddOption(options, MYX_B_COMMENT, CommentCBox.Checked);
  AddOption(options, MYX_B_DONT_WRITE_FULL_PATH, FullPathCBox.Checked);
  AddOption(options, MYX_B_ANSI_QUOTES, AnsiQuotesCBox.Checked);
  AddOption(options, MYX_B_LOCK_ALL_TABLES, LockAllTablesRButton.Checked);
  AddOption(options, MYX_B_SINGLE_TRANSACTION, SingleTransRButton.Checked);
  AddOption(options, MYX_B_DISABLE_KEYS, DisableKeysCBox.Checked);
  AddOption(options, MYX_B_COMPLETE_SCHEMATAS, CompleteSchematasCBox.Checked);

  Result:=options;
end;

procedure TAdminBackupForm.ApplyChanges;
var Profile: TMYX_BACKUP_PROFILE;
  Content: TMYX_BACKUP_CONTENT;
  BackupType: MYX_BACKUP_TYPE;
  filename: WideString;
  PAtInfo: pAT_INFO;
  h, m, s: WideString;
  JobId: Longword;
  ErrorNr: integer;
begin
  if(ScheduleCBox.Checked)then
  begin
    if(trim(ScheduleTargetDirEd.Text)='')then
      raise EInOutError.Create(_('You have to specify a target directory for the backup.'));

    if(trim(ScheduleFilenamePrefixEd.Text)='')then
      raise EInOutError.Create(_('You have to specify a filename prefix for the backup.'));
  end;

  //Get Backup FileType
  case BackupFileTypesLU.ItemIndex of
    0:
      BackupType:=MYX_BT_SQL_SCRIPT;
  else
    BackupType:=MYX_BT_SQL_SCRIPT;
  end;

  Content:=GetBackupContent(BackupTreeView);
  try
    Profile:=TMYX_BACKUP_PROFILE.create(ProjectNameEd.Text,
      '',
      GetOptions,
      BackupType,
      Content.get_record_pointer);
    try
      filename:=BackupProfileDir+ExtractText(ProjectNameEd.Text)+'.mbp';

      //Detect project name change
      if(OriginalProjectName<>ProjectNameEd.Text)then
        if(FileExists(BackupProfileDir+OriginalProjectName+'.mbp'))then
        begin
          DeleteFile(filename);
          DeleteFile(ChangeFileExt(filename, '.bak'));
          RenameFile(BackupProfileDir+OriginalProjectName+'.mbp',
            ChangeFileExt(filename, '.bak'));
        end;

      if(FileExists(filename))then
      begin
        DeleteFile(ChangeFileExt(filename, '.bak'));
        RenameFile(filename,
          ChangeFileExt(filename, '.bak'));
      end;

      myx_save_profile(ExtractFileName(filename),
        ExtractFilePath(filename),
        Profile.get_record_pointer);
    finally
      Profile.Free;
    end;

  finally
    Content.Free;
  end;

  //if the user scheduled a project
  if(ScheduleCBox.Checked)then
  begin
    //Make sure the service is running...
    GetSchedule('');

    RemoveSchedule(OriginalProjectName);

    JobId:=GetNextJobId;

    GetMem(PAtInfo, SizeOf(TAT_INFO));
    try
      h:=Copy(ScheduleTimeEd.Text, 1, Pos(':', ScheduleTimeEd.Text)-1);
      m:=Copy(ScheduleTimeEd.Text, Pos(':', ScheduleTimeEd.Text)+1, Length(ScheduleTimeEd.Text));
      PAtInfo.JobTime:=(StrToIntDef(h, 0)*60*60+StrToIntDef(m, 0)*60)*1000;
      PAtInfo.DaysOfMonth:=0;
      PAtInfo.DaysOfWeek:=0;
      if(ScheduleTypeCbox.ItemIndex=0)then
        PAtInfo.DaysOfWeek:=$7F
      else if(ScheduleTypeCbox.ItemIndex=1)then
      begin
        PAtInfo.DaysOfWeek:=
          (Ord(ScheduleMondayCBox.Checked)*$1) or
          (Ord(ScheduleTuesdayCBox.Checked)*$2) or
          (Ord(ScheduleWednesdayCBox.Checked)*$4) or
          (Ord(ScheduleThursdayCBox.Checked)*$8) or
          (Ord(ScheduleFridayCBox.Checked)*$10) or
          (Ord(ScheduleSaturdayCBox.Checked)*$20) or
          (Ord(ScheduleSundayCBox.Checked)*$40);
      end
      else
        PAtInfo.DaysOfMonth:=Trunc(Power(2, ScheduleDayOfMonthCBox.ItemIndex));

      PAtInfo.Flags:=JOB_RUN_PERIODICALLY;

      //Build command line
      s:='"'+Application.ExeName+'" ';

      //Connection file dir
      if(Pos(' ', MYXCommonOptions.UserDataDir)>0)then
        s:=s+'"-UD'+MYXCommonOptions.UserDataDir+'" '
      else
        s:=s+'-UD'+MYXCommonOptions.UserDataDir+' ';

      //Connection
      if(Pos(' ', MySQLConn.user_connection.connection_name)>0)then
        s:=s+'"-c'+MySQLConn.user_connection.connection_name+'" '
      else
        s:=s+'-c'+MySQLConn.user_connection.connection_name+' ';

      //Backup Profile
      if(Pos(' ', ProjectNameEd.Text)>0)then
        s:=s+'"-bp'+ProjectNameEd.Text+'" '
      else
        s:=s+'-bp'+ProjectNameEd.Text+' ';

      if(Pos(' ', trim(ScheduleTargetDirEd.Text))>0)then
        s:=s+'"-bt'+trim(ScheduleTargetDirEd.Text)+'" '
      else
        s:=s+'-bt'+trim(ScheduleTargetDirEd.Text)+' ';

      if(Pos(' ', trim(ScheduleFilenamePrefixEd.Text))>0)then
        s:=s+'"-bx'+trim(ScheduleFilenamePrefixEd.Text)+'"'
      else
        s:=s+'-bx'+trim(ScheduleFilenamePrefixEd.Text);

      PAtInfo.Command:=PWideChar(WideString(s));

      ErrorNr:=NetScheduleJobAdd(nil, PAtInfo, JobId);

      if(ErrorNr<>0)then
        raise EMyxSystemError.Create(_('Cannot schedule the backup task.'),
          ErrorNr);
    finally
      FreeMem(PAtInfo);
    end;
  end
  else
    RemoveSchedule(OriginalProjectName);

  ApplyBtn.Enabled:=False;
  //DiscardBtn.Enabled:=False;

  //if(ProjectListView.Selected=nil)then
  RefreshBackupProfiles(filename);
end;

procedure TAdminBackupForm.DiscardBtnClick(Sender: TObject);
begin
  DiscardChanges(False);
end;

procedure TAdminBackupForm.ApplyBtnClick(Sender: TObject);
begin
  ApplyChanges;
end;

function StrMatchesSearchStr(Str: WideString; searchStr: WideString): Boolean;
begin
  StrMatchesSearchStr:=True;

  if(searchStr<>'')then
    StrMatchesSearchStr:=(myx_match_string(Str,
      searchStr, 0)<>0);
end;

procedure TAdminBackupForm.RefreshBackupProfiles(SelectProfile: WideString);
var CurrentProfileName: WideString;
  SR: TSearchRec;
  filename: PChar;
  i: integer;
begin
  CurrentProfileName:=SelectProfile;
  {if(ProjectListView.Selected<>nil)then
    if(ProjectListView.Selected.Data<>nil)then
      CurrentProfileName:=PChar(ProjectListView.Selected.Data);}


  InitControls:=True;
  ProjectListView.Items.BeginUpdate;
  try
    ClearListView(ProjectListView, myx_ndt_pointer);

    if(FindFirst(BackupProfileDir+'*.mbp', faAnyFile and not
      (8 {faVolumeID} or faDirectory), sr)=0)then
    begin
      repeat
      begin
        if(AdvancedEditFrame.SearchEd.Text<>'')then
          if(Not(StrMatchesSearchStr(sr.Name, AdvancedEditFrame.SearchEd.Text)))then
            continue;

        GetMem(filename, Length(UTF8Encode(BackupProfileDir+sr.Name))+1);
        StrPCopy(filename, UTF8Encode(BackupProfileDir+sr.Name));

        AddListViewItem(ProjectListView, nil,
          ExtractFileName(Copy(sr.Name, 1, Length(sr.Name)-Length(ExtractFileExt(sr.Name)))),
          -1, filename);
      end;
      until FindNext(sr) <> 0;

      FindClose(sr);
    end;

    for i:=0 to ProjectListView.Items.Count-1 do
      if(ProjectListView.Items[i].Data<>nil)then
        if(CompareText(CurrentProfileName,
          UTF8Decode(PChar(ProjectListView.Items[i].Data)))=0)then
        begin
          ProjectListView.Selected:=ProjectListView.Items[i];
          break;
        end;
  finally
    ProjectListView.Items.EndUpdate;
    InitControls:=False;
  end;
end;

function TAdminBackupForm.InOptions(options: integer;
  option: MYX_BACKUP_OPTIONS): Boolean;
begin
  Result:=((options and ord(option))=Ord(option));
end;

procedure TAdminBackupForm.AddOption(var options: integer;
  option: MYX_BACKUP_OPTIONS; Add: Boolean);
begin
  if(Add)then
    options:=(options + ord(option));
end;

procedure TAdminBackupForm.LoadProfile(filename: WideString);
var Profile: TMYX_BACKUP_PROFILE;
  PProfile: PMYX_BACKUP_PROFILE;
  error: MYX_ADMIN_LIB_ERROR;
  AtEnum: TAtEnum;
  s: WideString;
  i, h, m: cardinal;
begin
  if(Not(MySQLConn.Connected))then
    Exit;

  PProfile:=myx_load_profile(ExtractFileName(filename),
    ExtractFilePath(filename), @error);
  if(error<>MYX_ADMIN_NO_ERROR)or(PProfile=nil)then
    raise EMyxAdminLibError.Create(_('Error while loading backup profile.'),
      Ord(error), filename);

  InitControls:=True;
  try
    Profile:=TMYX_BACKUP_PROFILE.create(PProfile);
  finally
    myx_free_profile(PProfile);
  end;

  try
    //Store original project name
    OriginalProjectName:=Profile.profile_name;

    ProjectNameEd.Text:=Profile.profile_name;

    BackupFileTypesLU.ItemIndex:=Ord(Profile.backup_type);

    NoCreatesCBox.Checked:=InOptions(Profile.options, MYX_B_NO_CREATES);
    NoExtendedInsertsCBox.Checked:=InOptions(Profile.options, MYX_B_NO_EXTENDED_INSERT);
    AddDropTableCBox.Checked:=InOptions(Profile.options, MYX_B_ADD_DROP_TABLE);
    CompleteInsertsCBox.Checked:=InOptions(Profile.options, MYX_B_COMPLETE_INSERTS);
    CommentCBox.Checked:=InOptions(Profile.options, MYX_B_COMMENT);
    FullPathCBox.Checked:=InOptions(Profile.options, MYX_B_DONT_WRITE_FULL_PATH);
    AnsiQuotesCBox.Checked:=InOptions(Profile.options, MYX_B_ANSI_QUOTES);
    LockAllTablesRButton.Checked:=InOptions(Profile.options, MYX_B_LOCK_ALL_TABLES);
    SingleTransRButton.Checked:=InOptions(Profile.options, MYX_B_SINGLE_TRANSACTION);
    DisableKeysCBox.Checked:=InOptions(Profile.options, MYX_B_DISABLE_KEYS);
    CompleteSchematasCBox.Checked:=InOptions(Profile.options, MYX_B_COMPLETE_SCHEMATAS);

    BuildContentTreeFromBackupContent(MySQLConn.PMySQL,
      BackupTreeView,
      Profile.backup_content,
      SchemataFrame,
      CompleteSchematasCBox.Checked);

    //Check if it is scheduled
    AtEnum:=GetSchedule(ProjectNameEd.Text);
    if(AtEnum.Command<>'')then
    begin
      ScheduleCBox.Checked:=True;

      //the param can be in "" or is terminated by a space or EOL
      ScheduleTargetDirEd.Text:='';
      if(Pos('"-bt', AtEnum.Command)>0)then
      begin
        s:=Copy(AtEnum.Command, Pos('"-bt', AtEnum.Command)+1, Length(AtEnum.Command));

        if(Pos('"', s)>0)then
          ScheduleTargetDirEd.Text:=Copy(s, 4, Pos('"', s)-4);
      end
      else if(Pos('-bt', AtEnum.Command)>0)then
      begin
        s:=Copy(AtEnum.Command, Pos('-bt', AtEnum.Command), Length(AtEnum.Command));

        if(Pos(' ', s)>0)then
          ScheduleTargetDirEd.Text:=Copy(s, 4, Pos(' ', s)-3)
        else
          ScheduleTargetDirEd.Text:=Copy(s, 4, Length(s));
      end;

      ScheduleFilenamePrefixEd.Text:='';
      if(Pos('"-bx', AtEnum.Command)>0)then
      begin
        s:=Copy(AtEnum.Command, Pos('"-bx', AtEnum.Command)+1, Length(AtEnum.Command));

        if(Pos('"', s)>0)then
          ScheduleFilenamePrefixEd.Text:=Copy(s, 4, Pos('"', s)-4);
      end
      else if(Pos('-bx', AtEnum.Command)>0)then
      begin
        s:=Copy(AtEnum.Command, Pos('-bx', AtEnum.Command), Length(AtEnum.Command));

        if(Pos(' ', s)>0)then
          ScheduleFilenamePrefixEd.Text:=Copy(s, 4, Pos(' ', s)-3)
        else
          ScheduleFilenamePrefixEd.Text:=Copy(s, 4, Length(s));
      end;

      h:= AtEnum.JobTime div (1000*60*60);
      m:= (AtEnum.JobTime mod (1000*60*60)) div (1000*60);
      ScheduleTimeEd.Text:= IntToStr(h);
      if(m<10)then
        ScheduleTimeEd.Text:= ScheduleTimeEd.Text + ':0' + IntToStr(m)
      else
        ScheduleTimeEd.Text:= ScheduleTimeEd.Text + ':' + IntToStr(m);

      if(AtEnum.DaysOfWeek<>0)then
      begin
        ScheduleMondayCBox.Checked:=((AtEnum.DaysOfWeek and $1)=$1)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleTuesdayCBox.Checked:=((AtEnum.DaysOfWeek and $2)=$2)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleWednesdayCBox.Checked:=((AtEnum.DaysOfWeek and $4)=$4)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleThursdayCBox.Checked:=((AtEnum.DaysOfWeek and $8)=$8)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleFridayCBox.Checked:=((AtEnum.DaysOfWeek and $10)=$10)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleSaturdayCBox.Checked:=((AtEnum.DaysOfWeek and $20)=$20)or(ScheduleTypeCbox.ItemIndex=0);
        ScheduleSundayCBox.Checked:=((AtEnum.DaysOfWeek and $40)=$40)or(ScheduleTypeCbox.ItemIndex=0);

        if(AtEnum.DaysOfWeek=$7F)then
          ScheduleTypeCbox.ItemIndex:=0
        else
          ScheduleTypeCbox.ItemIndex:=1;
      end
      else
      begin
        ScheduleDayOfMonthCBox.ItemIndex:=0;
        for i:=0 to 30 do
          if((AtEnum.DaysOfMonth and Trunc(Power(2, i)))=Power(2, i))then
          begin
            ScheduleDayOfMonthCBox.ItemIndex:=i;
            break;
          end;

        ScheduleTypeCbox.ItemIndex:=2;
      end;

      ScheduleTypeCboxCloseUp(self);

      //FreeMem(AtEnum);
    end
    else
      ScheduleCBox.Checked:=False;

    DisableEnableScheduleControls;

  finally
    InitControls:=False;
    Profile.Free;
  end;

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

function TAdminBackupForm.GetNextJobId: integer;
var Buffer, AtEnum: pAT_ENUM;
  ResultEnum: TAtEnum;
  EntriesRead : DWord;
  TotalEntries : DWord;
  ResumeHandle : DWord;
  i, res: integer;
  maxid: Cardinal;
begin
  maxid:=0;

  ResumeHandle:=0;

  repeat
  begin
    res:=NetScheduleJobEnum(nil, Buffer, DWORD(-1), EntriesRead, TotalEntries, ResumeHandle);

    ResultEnum.Command:='';
    for i:=0 to EntriesRead-1 do
    begin
      AtEnum:=pAT_ENUM(integer(Buffer)+sizeof(TAT_ENUM)*i);

      if(AtEnum.JobId>maxid)then
        maxid:=AtEnum.JobId;
    end;

    NetApiBufferFree(Buffer);
  end
  until (res<>234); //ERROR_MORE_DATA

  Result:=maxid+1;
end;

function TAdminBackupForm.GetSchedule(ProjectName: WideString): TAtEnum;
var Buffer, AtEnum: pAT_ENUM;
  ResultEnum: TAtEnum;
  EntriesRead : DWord;
  TotalEntries : DWord;
  ResumeHandle : DWord;
  i, res: integer;
  found: Boolean;
begin
  ResumeHandle:=0;
  found:=False;

  repeat
  begin
    res:=NetScheduleJobEnum(nil, Buffer, DWORD(-1), EntriesRead, TotalEntries, ResumeHandle);

    if(res<>0)then
      raise EMyxSystemError.Create(_('The connection to the scheduling service cannot be established. '+
        'Please make sure you have the "Taskplanner" service activated and running.'+
        'This can be checked with the Computer Management that is accessable in the '+
        'Administrative Tools in the Control Panel (Win2k/XP).'),
        res);

    ResultEnum.Command:='';
    for i:=0 to EntriesRead-1 do
    begin
      AtEnum:=pAT_ENUM(integer(Buffer)+sizeof(TAT_ENUM)*i);
      if(Pos('-bp'+ProjectName, AtEnum.Command)>0)then
      begin
        ResultEnum.JobId:=AtEnum.JobId;
        ResultEnum.JobTime:=AtEnum.JobTime;
        ResultEnum.DaysOfMonth:=AtEnum.DaysOfMonth;
        ResultEnum.DaysOfWeek:=AtEnum.DaysOfWeek;
        ResultEnum.Flags:=AtEnum.Flags;
        ResultEnum.Command:=WideCharToString(AtEnum.Command);

        found:=True;
        break;
      end;
    end;

    NetApiBufferFree(Buffer);

    if(found)then
      break;
  end
  until (res<>234); //ERROR_MORE_DATA

  Result:=ResultEnum;
end;

procedure TAdminBackupForm.RemoveSchedule(ProjectName: WideString);
var AtEnum: TAtEnum;
  ErrorNr: integer;
begin
  if(ProjectName='')then
    Exit;

  AtEnum:=GetSchedule(ProjectName);
  if(AtEnum.Command<>'')then
  begin
    ErrorNr:=NetScheduleJobDel(nil, AtEnum.JobId, AtEnum.JobId);

    //FreeMem(AtEnum);

    if(ErrorNr<>0)then
      raise EMyxSystemError.Create(_('Cannot schedule the backup task.'),
        ErrorNr);
  end;
end;


function TAdminBackupForm.GetSelectedTablesCount: integer;
var i, count: integer;
begin
  count:=0;

  for i:=0 to BackupTreeView.Items.Count-1 do
    if(BackupTreeView.Items[i].Data<>nil)then
      if(TObject(BackupTreeView.Items[i].Data) is TBackupNode)then
        if(TBackupNode(BackupTreeView.Items[i].Data).GetObjType=BOTTable)and
          (TBackupNode(BackupTreeView.Items[i].Data).GetSelectState=BCTAll)then
          inc(count);

  Result:=count;
end;

procedure TAdminBackupForm.RefreshProfilesMIClick(Sender: TObject);
begin
  RefreshBackupProfiles;
end;

procedure TAdminBackupForm.DeleteProfileMIClick(Sender: TObject);
var i: integer;
  filename: WideString;
begin
  if(ShowModalDialog(_('Delete Profiles?'),
    _('Are you sure you want to delete the selected profiles?'),
    myx_mtConfirmation,
    _('Yes')+#13#10+_('No'))=1) then
  begin
    InitControls:=True;
    try
      for i:=0 to ProjectListView.Items.Count-1 do
        if(ProjectListView.Items[i].Selected)then
          if(ProjectListView.Items[i].Data<>nil)then
          begin
            filename:=UTF8Decode(PChar(ProjectListView.Items[i].Data));
            RemoveSchedule(ChangeFileExt(
              ExtractFileName(filename), ''));

            DeleteFile(filename);
          end;

      RefreshBackupProfiles;

      ProjectListView.Selected:=nil;
      ClearControls(False);
    finally
      InitControls:=False;
    end;
  end;

end;

procedure TAdminBackupForm.ProfilesPopupMenuPopup(Sender: TObject);
begin
  DeleteProfileMI.Enabled:=ProjectListView.SelCount>0;
end;

procedure TAdminBackupForm.ClearCompleteContentMIClick(
  Sender: TObject);
begin
  ClearTreeView(BackupTreeView, myx_ndt_tobject);

  DoChange(self);

  StartBackupBtn.Enabled:=(GetSelectedTablesCount>0);
end;

procedure TAdminBackupForm.ProjectListViewSelectItem(
  Sender: TObject; Item: TListItem; Selected: Boolean);
var filename: WideString;
begin
  if(Not(InitControls))then
  begin
    if(ProjectListView.Selected<>nil)and
      (MySQLConn.Connected)then
    begin
      if(ProjectListView.Selected.Data<>nil)then
      begin
        filename:=UTF8Decode(PChar(ProjectListView.Selected.Data));

        if(ApplyBtn.Enabled)then
          DiscardChanges(True);

        LoadProfile(filename);

        DisableEnableControls(BackupContentTabSheet, True);
        DisableEnableControls(AdvancedOptionsTabSheet, True);
        DisableEnableControls(ScheduleTabSheet, True);
        DisableEnableScheduleControls;

        Exit;
      end;
    end
    else
      ClearControls(False);
  end;
end;

constructor TBackupThread.Create(
  AdminBackupForm: TAdminBackupForm;
  AdminBackupProgressForm: TAdminBackupProgressForm;
  filename: WideString);
begin
  inherited Create(True);

  self.AdminBackupForm:=AdminBackupForm;
  self.AdminBackupProgressForm:=AdminBackupProgressForm;
  self.filename:=filename;

  PMySQL:=myx_mysql_init();
  if(PMySQL=nil)then
    raise EMyxError.Create(_('Error while allocating memory for MySQL Struct in Backup Thread.'));

  
  if(myx_connect_to_instance(
    AdminBackupForm.MySQLConn.User_Connection.get_record_pointer,
    PMySQL)<>0)then
    raise EMyxError.Create(_('Backup Thread cannot connect to MySQL'));
end;

destructor TBackupThread.Destroy;
begin
  CleanUp;

  inherited Destroy;
end;

procedure TBackupThread.CleanUp;
begin
  myx_mysql_close(PMySQL);

  AdminBackupForm.BackupThread:=nil;

  Synchronize(FreeAdminBackupProgressForm);
end;

function BackupProgress(current_table_name: PChar;
  num_tables: Integer; num_tables_processed: Integer;
  num_rows: Integer; num_rows_processed: Integer; user_data: Pointer): integer;
var PSender: ^TBackupThread;
begin
  PSender:=user_data;

  with PSender.AdminBackupProgressForm do
  begin
    PSender.current_table_name:=current_table_name;
    PSender.num_tables:=num_tables;
    PSender.num_tables_processed:=num_tables_processed;
    PSender.num_rows:=num_rows;
    PSender.num_rows_processed:=num_rows_processed;
  end;

  PSender.Synchronize(PSender.UpdateProgressForm);

  Result:=Ord(PSender.AdminBackupProgressForm.Stopping);
end;

procedure TBackupThread.Execute;
var backup_content: TMYX_BACKUP_CONTENT;
begin
  with AdminBackupForm do
  begin
    backup_content:=GetBackupContent(BackupTreeView);
    try
      BackupError:=myx_make_backup(PMySQL, filename,
        backup_content.get_record_pointer, MYX_BT_SQL_SCRIPT,
        GetOptions, 256, BackupProgress, Addr(self));

      if(BackupError=MYX_BACKUP_NO_ERROR)then
        Synchronize(FinishedBackup)
      else
        Synchronize(ShowError);

    finally
      backup_content.Free;
    end;
  end;
end;

procedure TBackupThread.UpdateProgressForm;
begin
  with AdminBackupProgressForm do
  begin
    CurrentTableNameLbl.Caption:=
      current_table_name;

    TablesLbl.Caption:=IntToStr(num_tables);
    CurrentTableLbl.Caption:=IntToStr(num_tables_processed);
    TablesProgressBar.Max:=num_tables;
    TablesProgressBar.Position:=num_tables_processed-1;

    TotalRowsLbl.Caption:=IntToStr(num_rows);
    CurrentRowLbl.Caption:=IntToStr(num_rows_processed);
    RowProgressBar.Max:=num_rows;
    RowProgressBar.Position:=num_rows_processed-1;

    Refresh;
  end;
end;

procedure TBackupThread.FinishedBackup;
begin
  //Set Progress Bars to 100%
  num_tables_processed:=num_tables+1;
  num_rows_processed:=num_rows+1;

  UpdateProgressForm;

  ShowModalDialog(_('Backup finished'),
    _('The Backup was finished successfully.')+#13#10#13#10+
    format(_('The File %s has been created.'),[filename]),
    myx_mtConfirmation, _('OK'));
end;

procedure TBackupThread.FreeAdminBackupProgressForm;
begin
  if(AdminBackupProgressForm<>nil)then
    AdminBackupProgressForm.Free;
end;

procedure TBackupThread.ShowError;
var ErrorTxt: WideString;
begin
  if(ord(BackupError)=-1)then
  begin
    ShowModalDialog(_('Backup stopped'),
      _('The Backup has been stopped.'),
      myx_mtConfirmation, _('OK'));
  end
  else
  begin
    ErrorTxt:=GetBackupErrorMsg(BackupError);
    case BackupError of
      MYX_BACKUP_MYSQL_ERROR:
        ErrorTxt:=Format(ErrorTxt, [myx_mysql_errno(AdminBackupForm.MySQLConn.PMySQL),
          myx_mysql_error(AdminBackupForm.MySQLConn.PMySQL)]);
      MYX_BACKUP_CANT_OPEN_FILE:
        ErrorTxt:=Format(ErrorTxt, [filename]);
      MYX_BACKUP_OUTPUTDEVICE_FULL:
        ErrorTxt:=Format(ErrorTxt, [filename]);
    end;

    ShowModalDialog(_('Backup error'),
      _('An Error occured while executing the backup.')+#13#10#13#10+
      ErrorTxt,
      myx_mtConfirmation, _('OK'));
  end;
end;

procedure TAdminBackupForm.Disconnected(var Message: TMessage);
begin
  ClearControls(False);

  NewProjectBtn.Enabled:=False;

  ProjectListView.Selected:=nil;
end;

procedure TAdminBackupForm.Reconnected(var Message: TMessage);
begin
  NewProjectBtn.Enabled:=True;

  SchemataFrame.RefreshSchemaTree;

  ProjectListView.Selected:=nil;
end;

procedure TAdminBackupForm.SchemaListChanged(var Message: TMessage);
begin
  SchemataFrame.ReloadSchemaTree;
  SchemataFrame.RefreshSchemaTree;
end;

procedure TAdminBackupForm.AdvancedEditFrameSearchEdChange(
  Sender: TObject);
begin
  AdvancedEditFrame.SearchEdChange(Sender);

  RefreshBackupProfiles;
end;

procedure TAdminBackupForm.ScheduleCBoxClick(Sender: TObject);
var OptionsForm: TOptionsForm;
begin
  //Check if service is available
  try
    GetSchedule('');
  except
    ScheduleCBox.Checked:=False;
    raise;
  end;

  if(ScheduleCBox.Checked)then
  begin
    if(MYXCommonOptions.PasswordStorageType<>MYX_PASSWORD_OBSCURED)then
      if(ShowModalDialog(_('Attention!'),
        _('You have to enable the Password Storage option on the '+
          'programm''s General Options tabsheet and select Obscured as '+
          'password storage method to execute scheduled '+
          'backups. Otherwise the backup task cannot log into '+
          'the database.'),
          myx_mtError, _('OK')+#13#10+_('Open Options'))=2)then
      begin
        OptionsForm:=TOptionsForm.Create(self, TAdminOptionPagesForm.Create(self));
        try
          OptionsForm.ShowModal;
        finally
          OptionsForm.Free;
        end;
      end;

    if(trim(ScheduleTargetDirEd.Text)='')then
      ScheduleTargetDirEd.Text:='C:\';

    if(trim(ScheduleFilenamePrefixEd.Text)='')then
      ScheduleFilenamePrefixEd.Text:=ProjectNameEd.Text;
  end;

  DisableEnableScheduleControls;
  DoChange(self);
end;

procedure TAdminBackupForm.ScheduleTypeCboxCloseUp(Sender: TObject);
begin
  SchedulePageControl.ActivePageIndex:=ScheduleTypeCbox.ItemIndex;

  DoChange(self);
end;

procedure TAdminBackupForm.SchemataFrameCatalogVSTMouseMove(
  Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if(ssLeft	in Shift)then
  begin
    //Simulate Treshold before Drag
    if((abs(MousePos.X-Mouse.CursorPos.X)>5)or
      (abs(MousePos.Y-Mouse.CursorPos.Y)>5))then
      SchemataFrame.CatalogVST.BeginDrag(True);
  end;
end;

procedure TAdminBackupForm.SchemataFrameCatalogVSTDblClick(
  Sender: TObject);
begin
  //Prevent user from doubleclicking
  Abort;
end;

end.
