unit AdminOptionPages;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Options, AuxFuncs, TntComCtrls, TntStdCtrls;

type
  TAdminOptionPagesForm = class(TApplicationOptionsForm)
    OptionPageControl: TTntPageControl;
    AdminGeneralTabSheet: TTabSheet;
    GroupBox4: TTntGroupBox;
    AdminShowGlobalPrivCBox: TTntCheckBox;
    AdminShowTblColPrivCBox: TTntCheckBox;
    GroupBox1: TTntGroupBox;
    UsePeakLevelCBox: TTntCheckBox;
    ResetPeakLevelCBox: TTntCheckBox;
    PeakLevelResetTicksEd: TTntEdit;
    PeakLevelResetTicksUpDown: TTntUpDown;
    PeakLevelResetTicksLbl: TTntLabel;
    GroupBox2: TTntGroupBox;
    AddDateTimeToBackupFilesCBox: TTntCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure SetControls(PageNr: integer); override;
    procedure ApplyChanges(PageNr: integer); override;

    procedure DoChange(Sender: TObject);
    procedure EnableDisableControls;

    procedure ResetPeakLevelCBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses ApplicationDataModule;

{$R *.dfm}

procedure TAdminOptionPagesForm.FormCreate(Sender: TObject);
begin
  InitForm(self);

  OptionsImgNames.Add('options_admin');

  DockOptionPageControl:=OptionPageControl;
end;

procedure TAdminOptionPagesForm.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TAdminOptionPagesForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;

procedure TAdminOptionPagesForm.SetControls(PageNr: integer);
begin
  if(PageNr=0)then
  begin
    AdminShowGlobalPrivCBox.Checked:=ApplicationDM.Options.ShowUserGlobalPrivileges;
    AdminShowTblColPrivCBox.Checked:=ApplicationDM.Options.ShowUserTableColumnPrivileges;

    UsePeakLevelCBox.Checked:=ApplicationDM.Options.UsePeakLevel;
    ResetPeakLevelCBox.Checked:=ApplicationDM.Options.ResetPeakLevel;
    PeakLevelResetTicksUpDown.Position:=ApplicationDM.Options.PeakLevelResetTicks;

    AddDateTimeToBackupFilesCBox.Checked:=ApplicationDM.Options.AddDateTimeToBackupFiles;

    EnableDisableControls;
  end;
end;

procedure TAdminOptionPagesForm.ApplyChanges(PageNr: integer);
begin
  if(PageNr=0)then
  begin
    ApplicationDM.Options.ShowUserGlobalPrivileges:=AdminShowGlobalPrivCBox.Checked;
    ApplicationDM.Options.ShowUserTableColumnPrivileges:=AdminShowTblColPrivCBox.Checked;

    ApplicationDM.Options.UsePeakLevel:=UsePeakLevelCBox.Checked;
    ApplicationDM.Options.ResetPeakLevel:=ResetPeakLevelCBox.Checked;
    ApplicationDM.Options.PeakLevelResetTicks:=PeakLevelResetTicksUpDown.Position;

    ApplicationDM.Options.AddDateTimeToBackupFiles:=AddDateTimeToBackupFilesCBox.Checked;
  end;
end;

procedure TAdminOptionPagesForm.DoChange(Sender: TObject);
begin
  if(@DoPageContentChanged<>nil)then
    DoPageContentChanged(Sender);
end;

procedure TAdminOptionPagesForm.EnableDisableControls;
begin
  PeakLevelResetTicksEd.Enabled:=ResetPeakLevelCBox.Checked;
  PeakLevelResetTicksUpDown.Enabled:=ResetPeakLevelCBox.Checked;
  PeakLevelResetTicksLbl.Enabled:=ResetPeakLevelCBox.Checked;
end;

procedure TAdminOptionPagesForm.ResetPeakLevelCBoxClick(Sender: TObject);
begin
  DoChange(Sender);

  EnableDisableControls;
end;

end.
