Unit ScheduleAPI;

interface

{ ** Schedule - Win NT only (UniCode)
***************************************** }

const
  JOB_RUN_PERIODICALLY = $01;    { in-/output flag }
  JOB_EXEC_ERROR       = $02;    { output flag     }
  JOB_RUNS_TODAY       = $04;    { output flag     }
  JOB_ADD_CURRENT_DATE = $08;    { input flag      }
  JOB_NONINTERACTIVE   = $10;    { in-/output flag }

type
  DWORD = Longword;

  TAT_INFO = record
    JobTime     : DWord; { ms from midnight }
    DaysOfMonth : DWord; { Bit # equeals day of month ( bit 0 = day 1 ) }
    DaysOfWeek  : Byte;  { Bit # equeals day of week ( bit 0 = monday ) }
    Flags       : Byte;  { Job state flags - see above }
    Command     : pWideChar; { command line - UniCode only }
  end;
  pAT_INFO = ^TAT_INFO;

  TAT_ENUM = record
    JobId       : DWord; { Job identification number }
    JobTime     : DWord; { ms from midnight }
    DaysOfMonth : DWord; { Bit # equeals day of month ( bit 0 = day 1 ) }
    DaysOfWeek  : byte;  { Bit # equeals day of week ( bit 0 = monday ) }
    Flags       : Byte;  { Job state flags - see above }
    Command     : pWideChar; { command line - UniCode only }
  end;
  pAT_ENUM = ^TAT_ENUM;


function NetScheduleJobAdd(Servername:pWideChar;
                             Buffer:pAT_Info;
                             Var JobId:DWord): integer; stdcall;
function NetScheduleJobDel(Servername:pWideChar;
                             MinJobId:DWord;
                             MaxJobId:DWord): integer; stdcall;
procedure NetScheduleJobGetInfo(Servername:pWideChar;
                             JobId : DWord;
                             Var Buffer : pAT_INFO); stdcall;
function NetScheduleJobEnum(Servername:pWideChar;
                             Var Buffer : pAT_ENUM;
                             PreferredMaximumLength : DWord;
                             Var EntriesRead : DWord;
                             Var TotalEntries : DWord;
                             Var ResumeHandle : DWord): integer; stdcall;
function NetApiBufferFree(Buffer: Pointer): integer; stdcall;

implementation

{ ** Schedule - Win NT only (UniCode)
***************************************** }
CONST
  Schedule = 'NetApi32.DLL';

function NetScheduleJobAdd;      external schedule name 'NetScheduleJobAdd';
function NetScheduleJobDel;      external schedule name 'NetScheduleJobDel';
procedure NetScheduleJobGetInfo; external schedule name 'NetScheduleJobGetInfo';
function NetScheduleJobEnum;     external schedule name 'NetScheduleJobEnum';
function NetApiBufferFree;       external schedule name 'NetApiBufferFree';

end.

